-- This lua file contains all the related definemods, aliases and setdefaults that make it pretty close to nITG, modding-wise.
-- Or, at least as close as I can get with 5.0.12 and without using SM5 splines.
xero()

local notefieldmid = (THEME:GetMetric("Player","ReceptorArrowsYStandard") + THEME:GetMetric("Player","ReceptorArrowsYReverse") )

-- zoom
definemod {
	'zoom', 'zoomx', 'zoomy', 'zoomz', 'mini',
	function(zoom, x, y, z, mini, pn)
		local m = zoom * 0.01
		local zoomz = z*0.01
		local zoomznf = (1/(1-0.005*m))
		if NFW[pn] then NFW[pn]:zoomx(m * x * 0.01):zoomy(m * y * 0.01):zoomz(zoomz * zoomznf) end
		return mini
	end,
	'mini',
	defer=true
}

setdefault {
	100, 'zoom',
	100, 'zoomx',
	100, 'zoomy',
	100, 'zoomz'
}

-- xmod
definemod {
	'xmod', 'cmod',
	function(xmod, cmod, pn)
		if cmod == 0 then
			mod_buffer[pn](string.format('*10000 %fx', xmod))
		else
			mod_buffer[pn](string.format('*10000 %fx,*10000 c%f', xmod, cmod))
		end
	end,
	defer = true
}

-- rotation & position
{
	'x', 'y', 'z', 'rotationx', 'rotationy', 'rotationz',
	function(x, y, z, rx, ry, rz, pn)
		if NFW[pn] then
			local modrot = math.abs(rx % 360)
			local ypos = modrot > 180 and notefieldmid*((360-modrot)/180) or notefieldmid*(modrot/180)
			NFW[pn]:x(x):y(y+ypos):z(z):rotationx(rx):rotationy(ry):rotationz(rz)
		end
	end,
	defer = true
}

--Other modtweens
{
	'hide',
	function(n, pn)
		if P[pn] then NFW[pn]:visible(n <= 0) end
	end
}
{
	'skewx',
	function(n, pn)
		if P[pn] then NFW[pn]:skewx(n*0.01) end
	end
}
{
	'skewy',
	function(n, pn)
		if P[pn] then NFW[pn]:skewy(n*0.01) end
	end
}
